@c -*-texinfo-*-
@c 
@c GNU libavl - library for manipulation of binary trees.
@c Copyright (C) 1998-2002 Free Software Foundation, Inc.
@c 
@c This program is free software; you can redistribute it and/or
@c modify it under the terms of the GNU General Public License as
@c published by the Free Software Foundation; either version 2 of
@c the License, or (at your option) any later version.
@c 
@c This program is distributed in the hope that it will be useful,
@c but WITHOUT ANY WARRANTY; without even the implied warranty of
@c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@c General Public License for more details.
@c 
@c You should have received a copy of the GNU General Public License
@c along with this program; if not, write to: Free Software
@c Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
@c 02111-1307, USA.
@c 
@c The author may be contacted as blp@gnu.org on the Internet, or
@c write to Ben Pfaff, 12167 Airport Rd, DeWitt MI 48820, USA.

@node References, Supplementary Code, Red-Black Trees with Parent Pointers, Top
@appendix References

@bibdfn{Aho 1986} Aho, A.@: V., R.@: Sethi, and J.@: D.@: Ullman,
@cite{Compilers: Principles, Techniques, and Tools}.  Addison-Wesley,
1986.  ISBN 0-201-10088-6.

@bibdfn{Bentley 2000} Bentley, J., @cite{Programming Pearls}, 2nd ed.
Addison-Wesley, 2000.  ISBN 0-201-65788-0.

@bibdfn{Brown 2001} Brown, S., ``Identifiers NOT To Use in C Programs''.
Oak Road Systems, Feb. 15, 2001.
@uref{http://www.oakroadsystems.com/tech/c-predef.htm}.

@bibdfn{Cormen 1990} Cormen, C.@: H., C.@: E.@: Leiserson, and R.@: L.@:
Rivest, @cite{Introduction to Algorithms}.  McGraw-Hill, 1990.  ISBN
0-262-03141-8.

@bibdfn{FSF 1999} Free Software Foundation, @cite{GNU C Library
Reference Manual}, version 0.08, 1999.

@bibdfn{FSF 2001} Free Software Foundation, ``GNU Coding Standards'',
ed. of March 23, 2001.

@bibdfn{ISO 1990} International Organization for Standardization,
@cite{ANSI/ISO 9899-1990: American National Standard for Programming
Languages---C}, 1990.  Reprinted in @cite{The Annotated ANSI C
Standard}, ISBN 0-07-881952-0.

@bibdfn{ISO 1998} International Organization for Standardization,
@cite{ISO/IEC 14882:1998(E): Programming languages---C++}, 1998.

@bibdfn{ISO 1999} International Orgnaization for Standardization,
@cite{ISO/IEC 9899:1999: Programming Languages---C}, 2nd ed., 1999.

@bibdfn{Kernighan 1976} Kernighan, B.@: W., and P.@: J.@: Plauger,
@cite{Software Tools}.  Addison-Wesley, 1976.  ISBN 0-201-03669-X.

@bibdfn{Kernighan 1988} Kernighan, B.@: W., and D.@: M.@: Ritchie,
@cite{The C Programming Language}, 2nd ed.  Prentice-Hall, 1988.  ISBN
0-13-110362-8.

@bibdfn{Knuth 1997} Knuth, D.@: E., @cite{The Art of Computer
Programming, Volume 1: Fundamental Algorithms}, 3rd ed.  Addison-Wesley,
1997.  ISBN 0-201-89683-4.

@bibdfn{Knuth 1998a} Knuth, D.@: E., @cite{The Art of Computer
Programming, Volume 2: Seminumerical Algorithms}, 3rd ed.
Addison-Wesley, 1998.  ISBN 0-201-89684-2.

@bibdfn{Knuth 1998b} Knuth, D.@: E., @cite{The Art of Computer
Programming, Volume 3: Sorting and Searching}, 2nd ed.  Addison-Wesley,
1998.  ISBN 0-201-89685-0.

@bibdfn{Knuth 1977} Knuth, D.@: E., ``Deletions that Preserve
Randomness'', @cite{IEEE Trans. on Software Eng.} SE-3 (1977),
pp. 351--9.  Reprinted in @bibref{Knuth 2000}.

@bibdfn{Knuth 1978} Knuth, D.@: E., ``A Trivial Algorithm Whose Analysis
Isn't'', @cite{Journal of Algorithms} 6 (1985), pp. 301--22.  Reprinted
in @bibref{Knuth 2000}.

@bibdfn{Knuth 1992} Knuth, D.@: E., @cite{Literate Programming}, CSLI
Lecture Notes Number 27.  Center for the Study of Language and
Information, Leland Stanford Junior University, 1992.  ISBN
0-9370-7380-6.

@bibdfn{Knuth 2000} Knuth, D.@: E., @cite{Selected Papers on Analysis of
Algorithms}, CSLI Lecture Notes Number 102.  Center for the Study of
Language and Information, Leland Stanford Junior University, 2000.  ISBN
1-57586-212-3.

@bibdfn{Pfaff 1998} Pfaff, B.@: L., ``An Iterative Algorithm for
Deletion from AVL-Balanced Binary Trees''.  Presented July 1998, annual
meeting of Pi Mu Epsilon, Toronto, Canada.
@uref{http://www.msu.edu/user/pfaffben/avl/}.

@bibdfn{Sedgewick 1998} Sedgewick, R., @cite{Algorithms in C, Parts
1-4}, 3rd ed.  Addison-Wesley, 1998.  ISBN 0-201-31452-5.

@bibdfn{SGI 1993} Silicon Graphics, Inc., @cite{Standard Template Library
Programmer's Guide}.  @uref{http://www.sgi.com/tech/stl/}.

@bibdfn{Stout 1986} Stout, F.@: S. and B.@: L.@: Warren, ``Tree
Rebalancing in Optimal Time and Space'', @cite{Communications of the
ACM} 29 (1986), pp. 902--908.

@bibdfn{Summit 1999} Summit, S.@:, ``comp.lang.c Answers to Frequently
Asked Questions'', version 3.5.
@uref{http://www.eskimo.com/~scs/C-faq/top.html}.  ISBN 0-201-84519-9.
